/*
  DrawEx Library.
  (c) Emil Biserov (aka fatty) 2001
  (c) Alexey Makhmutov (aka Lerm) 2003,2004

  Published under GPL license
*/

#include <stdrom.h>
#include <define.h>
#include <libc.h>
#include <l_define.h>

/*  
  Style:
  IB_GPFOVER - OVER Write  
  IB_GPFOR   - OR Write  
  IB_GPFAND  - AND Write
  IB_GPFREV  - REVERSE Write
  IB_GPFMESH - MESH Write
*/
int LibPutProFontEx(byte type, byte code, int x_pos,int y_pos, byte style) 
{
  union REGS regs;
  regs.h.ah = style;
  regs.h.al = type;
  regs.x.bx = code;
  regs.x.cx = x_pos;
  regs.x.dx = y_pos;
  int86(GDSBIO, &regs, &regs);
  return regs.x.cx;
}

/*
  Style:
  IB_GPFOVER - OVER Write  
  IB_GPFOR   - OR Write  
  IB_GPFAND  - AND Write
  IB_GPFREV  - REVERSE Write
  IB_GPFMESH - MESH Write
*/
void LibPutProStrEx(byte type,int x,int y,byte *string,int x_size, byte style)
{
  auto int x_pos = x;
  while (*string)
  {
    if ( x_pos + LibGetProFontSize(type, *string) > x + x_size )      
      break;    
    x_pos = LibPutProFontEx(type, *string, x_pos, y, style);    
    string++;
  }
}

/* 
  Style:
  IB_FMOVER - OVER Write
  IB_FMOR   - OR Write
  IB_FMAND  - AND Write 
  IB_FMREV  - REVERSE Write 
  IB_FMMESH - MESH Write
*/
void LibPutMessageEx(word no,int p_x,int p_y,byte type, byte style)
{  
  union REGS regs;
  regs.h.ah = style;
  regs.h.al = type;
  regs.x.bx = no;
  regs.x.cx = p_x;
  regs.x.dx = p_y;
  int86(GDSBIO, &regs, &regs);
} 


/*
  Style:
  IB_FGPOVER - OVER Write
  IB_FGPOR   - OR Write
  IB_FGPAND  - AND Write
  IB_FGPREV  - REVERSE Write
  IB_FGPMESH - MESH Write
*/
void LibPutFarDataEx(int x, int y, int no, byte style)
{  
  union REGS regs;
  regs.x.ax = no;
  regs.h.ah = style;
  regs.x.bx = no;
  regs.x.cx = x;
  regs.x.dx = y;
  int86(FGDSGRA, &regs, &regs);
} 
